﻿Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Data
Imports Infragistics.Web.UI
Imports Infragistics.Web.UI.ListControls
Imports Infragistics.Web.UI.GridControls


Public Class _Default
    Inherits System.Web.UI.Page


    Private Sub Page_Init(sender As Object, e As System.EventArgs) Handles Me.Init
        SetGridDefaultSettings("OrderId")
    End Sub


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '/reference to the custom provider   
        Dim poDropDownProvider As GridControls.DropDownProvider = Nothing

        If (Not IsPostBack) Then
            '-----  Drop Down Provider  ------
            poDropDownProvider = New GridControls.DropDownProvider()
            poDropDownProvider.ID = "DropDownProvider1"
            WebDataGrid1.EditorProviders.Add(poDropDownProvider)

            '/hooks up the provider to the column by key   
            Dim poColumnSetting As GridControls.EditingColumnSetting = New GridControls.EditingColumnSetting()

            poColumnSetting.ColumnKey = "CompanyId"
            poColumnSetting.EditorID = poDropDownProvider.ID
            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(poColumnSetting)

            '-----  Text Editor Provider  ------
            Dim poTextEditorProvider As GridControls.TextEditorProvider = New GridControls.TextEditorProvider("TextEditProvider1")

            WebDataGrid1.EditorProviders.Add(poTextEditorProvider)

            poColumnSetting = New GridControls.EditingColumnSetting()
            poColumnSetting.ColumnKey = "OrderId"
            poColumnSetting.ReadOnly = True
            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(poColumnSetting)

            poColumnSetting = New GridControls.EditingColumnSetting()
            poColumnSetting.ColumnKey = "ISBN"
            poColumnSetting.ReadOnly = True
            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(poColumnSetting)

            '-----  Date Picker Provider  ------
            Dim poDatePickerProvider As GridControls.DatePickerProvider = New GridControls.DatePickerProvider("DateInputProvider1")

            WebDataGrid1.EditorProviders.Add(poDatePickerProvider)

            poColumnSetting = New GridControls.EditingColumnSetting()
            poColumnSetting.ColumnKey = "OrderDate"
            'poColumnSetting.EditorID = poDatePickerProvider.ID
            poColumnSetting.ReadOnly = False
            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(poColumnSetting)

            '-----  Numeric Editor Provider  ------
            Dim poNumericEditorProvider As GridControls.NumericEditorProvider = New GridControls.NumericEditorProvider("NumericEditorProvider1")

            WebDataGrid1.EditorProviders.Add(poNumericEditorProvider)

            poColumnSetting = New GridControls.EditingColumnSetting()
            poColumnSetting.ColumnKey = "QuantityNeeded"
            poColumnSetting.EditorID = poNumericEditorProvider.ID
            poColumnSetting.ReadOnly = False
            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(poColumnSetting)

            '------  Slider Provider  ---------
            Dim poSliderProvider As GridControls.SliderProvider = New GridControls.SliderProvider("QuantityValueProvider1")

            poSliderProvider.EditorControl.ID = "EditorControl1"
            poSliderProvider.EditorControl.MinValueAsString = 0
            poSliderProvider.EditorControl.MaxValueAsString = 100
            poSliderProvider.EditorControl.ContentAlignment = EditorControls.SliderContentAlignment.Center
            poSliderProvider.EditorControl.ValueType = EditorControls.SliderValueType.Int
            poSliderProvider.EditorControl.Width = 200
            poSliderProvider.EditorControl.EnableViewState = True
            poSliderProvider.EditorControl.EnableAjaxViewState = True

            WebDataGrid1.EditorProviders.Add(poSliderProvider)

            poColumnSetting = New GridControls.EditingColumnSetting()
            poColumnSetting.ColumnKey = "PercentComplete"
            poColumnSetting.EditorID = poSliderProvider.ID
            poColumnSetting.ReadOnly = False
            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(poColumnSetting)

        Else
            '/gets a reference to the dropdown provider when posting back   
            For Each epd As GridControls.EditorProviderBase In WebDataGrid1.EditorProviders
                If (epd.ID = "DropDownProvider1") Then
                    poDropDownProvider = CType(epd, GridControls.DropDownProvider)
                End If
            Next
        End If

        '-- gets the WebDropDown and binds it the lookup data  
        Dim poCompanyDropDown As WebDropDown = CType(poDropDownProvider.GetEditor(), WebDropDown)
        poCompanyDropDown.TextField = "CompanyName"
        poCompanyDropDown.ValueField = "CompanyId"
        poCompanyDropDown.DataSource = MakeLookUpTable()
        poCompanyDropDown.DataBind()
        poCompanyDropDown.ID = "editor1"

        '-- To get an image in the column header, you need to create a template with an image and apply the template.
        Dim commentsHeader As Infragistics.Web.UI.ItemTemplate = New Infragistics.Web.UI.ItemTemplate()

        Dim commentsHeaderTemplate As CustomImageColumnHeader = New CustomImageColumnHeader("images/Notes.png", "Comments")

        commentsHeader.TemplateID = "Comments"
        commentsHeader.Template = commentsHeaderTemplate

        WebDataGrid1.Templates.Add(commentsHeader)

        WebDataGrid1.DataSource = GetGridData()
        WebDataGrid1.DataBind()
    End Sub


    Private Function GetGridData() As DataTable
        Dim dt As DataTable = New DataTable()

        Try
            If Session("data") Is Nothing Then
                Session("data") = MakeTable()
            End If
            dt = CType(Session("data"), DataTable)

            If Not IsPostBack Then
                Dim colIndex As Integer = -1

                For Each column As DataColumn In dt.Columns
                    Select Case column.ColumnName
                        Case "Status"
                            Dim tc As GridControls.TemplateDataField = New GridControls.TemplateDataField(True)

                            tc.ItemTemplate = New CustomImageColumnHeader("images/Delete.png", "Cancelled")

                            tc.Key = column.ColumnName
                            tc.Header.Tooltip = column.Caption
                            tc.Header.Text = "Status"

                            colIndex = WebDataGrid1.Columns.Add(tc)

                        Case Else
                            Dim bc As GridControls.BoundDataField = New GridControls.BoundDataField(True)

                            bc.Key = column.ColumnName
                            bc.DataFieldName = column.ColumnName
                            bc.DataType = column.DataType.ToString()
                            bc.Header.Text = column.Caption
                            bc.Header.Tooltip = column.Caption

                            Select Case column.ColumnName
                                Case "OrderId", "ISBN"
                                    bc.CssClass = "readonly-cell"

                                Case "OrderDate"
                                    bc.DataFormatString = "{0:d}"

                                Case "Comments"
                                    bc.Header.TemplateId = "Comments"
                                    bc.Header.Text = String.Empty
                                Case Else
                            End Select

                            colIndex = WebDataGrid1.Columns.Add(bc)
                    End Select
                Next
            End If

        Catch ex As Exception
            Throw ex
        End Try

        Return dt
    End Function


    Private Function MakeTable() As DataTable
        'Create a new DataTable.
        Dim table As System.Data.DataTable = New DataTable("Orders")
        '/ Declare variables for DataColumn and DataRow objects.
        Dim column As DataColumn
        Dim row As DataRow

        '/ Create new DataColumn, set DataType, 
        '/ ColumnName and add to DataTable.    
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.Int32")
        column.ColumnName = "OrderId"
        column.Caption = "Order Id"
        column.ReadOnly = True
        '/ Add the Column to the DataColumnCollection.
        table.Columns.Add(column)

        '/ Create column 2.
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.DateTime")
        column.ColumnName = "OrderDate"
        column.Caption = "Order Date"

        '/ Add the column to the table. 
        table.Columns.Add(column)

        '/ Create column 3.
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.String")
        column.ColumnName = "ISBN"
        column.Caption = "ISBN"
        column.ReadOnly = True
        '/ Add the column to the table. 
        table.Columns.Add(column)

        '/ Create column 4.
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.String")
        column.ColumnName = "Author"
        column.Caption = "Author"
        '/ Add the column to the table. 
        table.Columns.Add(column)

        '/ Create column 5
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.String")
        column.ColumnName = "CompanyId"
        column.Caption = "Company"
        '/ Add the column to the table.
        table.Columns.Add(column)

        '/ Create column 6.
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.Int32")
        column.ColumnName = "QuantityNeeded"
        column.Caption = "Quantity"
        '/ Add the column to the table. 
        table.Columns.Add(column)

        '/ Create column 7.
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.Double")
        column.ColumnName = "PercentComplete"
        column.Caption = "% Complete"
        '/ Add the column to the table. 
        table.Columns.Add(column)

        '/ Create column 8.
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.Boolean")
        column.ColumnName = "Comments"
        column.Caption = "Comments"
        '/ Add the column to the table. 
        table.Columns.Add(column)

        '/ Create column 9.
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.Int32")
        column.ColumnName = "StatusId"
        column.Caption = "StatusId"
        column.ReadOnly = True
        column.ColumnMapping = MappingType.Hidden
        '/ Add the column to the table. 
        table.Columns.Add(column)

        '/ Create column 10.
        column = New DataColumn()
        'column.DataType = System.Type.GetType("System.Object")
        column.ColumnName = "Status"
        column.Caption = "Status"
        column.ReadOnly = True
        '/ Add the column to the table. 
        table.Columns.Add(column)

        '/ Make the ID column the primary key column.
        Dim PrimaryKeyColumns(1) As DataColumn
        PrimaryKeyColumns(0) = table.Columns("OrderId")
        table.PrimaryKey = PrimaryKeyColumns

        For i As Integer = 0 To 20
            row = table.NewRow()
            row("OrderId") = i
            row("OrderDate") = CDate(Date.Now().AddYears(-4).AddMonths(i))
            row("ISBN") = "ISBN " & i
            row("Author") = "Author " & i
            row("CompanyId") = (i * 100)
            row("QuantityNeeded") = ((i + 1) * 2)
            row("PercentComplete") = (i * 5)
            row("Comments") = (i Mod 2)
            row("StatusId") = (i Mod 5) + 1
            row("Status") = String.Empty

            table.Rows.Add(row)
        Next

        table.AcceptChanges()

        Return table
    End Function


    Private Function MakeLookUpTable() As DataTable
        'Create a new DataTable.
        Dim table As System.Data.DataTable = New DataTable("Company")
        '/ Declare variables for DataColumn and DataRow objects.
        Dim column As DataColumn
        Dim row As DataRow

        '/ Create new DataColumn, set DataType, 
        '/ ColumnName and add to DataTable.    
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.Int32")
        column.ColumnName = "CompanyId"
        column.ReadOnly = True
        '/ Add the Column to the DataColumnCollection.
        table.Columns.Add(column)

        '/ Create second column.
        column = New DataColumn()
        column.DataType = System.Type.GetType("System.String")
        column.ColumnName = "CompanyName"
        column.AutoIncrement = False
        column.Caption = "Company Name"
        column.ReadOnly = True
        column.Unique = False
        '/ Add the column to the table. 
        table.Columns.Add(column)

        '/ Make the ID column the primary key column.
        Dim PrimaryKeyColumns(1) As DataColumn
        PrimaryKeyColumns(0) = table.Columns("CompanyId")
        table.PrimaryKey = PrimaryKeyColumns

        For i As Integer = 0 To 20
            row = table.NewRow()
            row("CompanyId") = i * 100
            row("CompanyName") = "Company " & (i * 100)
            table.Rows.Add(row)
        Next

        table.AcceptChanges()

        Return table
    End Function


    Private Sub WebDataGrid1_InitializeRow(sender As Object, e As Infragistics.Web.UI.GridControls.RowEventArgs) Handles WebDataGrid1.InitializeRow
        Try
            Dim poStatusId As GridRecordItem = e.Row.Items.FindItemByKey("StatusId")
            Dim poStatus As GridRecordItem = e.Row.Items.FindItemByKey("Status")

            Select Case poStatusId.Value
                Case 1
                    CType(CType(poStatus.Column, TemplateDataField).ItemTemplate, CustomImageColumnHeader).SetValues("images/Add.png", "New")

                Case 2
                    CType(CType(poStatus.Column, TemplateDataField).ItemTemplate, CustomImageColumnHeader).SetValues("images/Config.png", "Setup")

                Case 3
                    CType(CType(poStatus.Column, TemplateDataField).ItemTemplate, CustomImageColumnHeader).SetValues("images/Go.png", "Processing")

                Case 4
                    CType(CType(poStatus.Column, TemplateDataField).ItemTemplate, CustomImageColumnHeader).SetValues("images/Check.png", "Completed")

                Case 5
                    CType(CType(poStatus.Column, TemplateDataField).ItemTemplate, CustomImageColumnHeader).SetValues("images/Delete.png", "Cancelled")

            End Select

        Catch ex As Exception

        End Try

    End Sub


    Private Sub WebDataGrid1_RowUpdated(sender As Object, e As Infragistics.Web.UI.GridControls.RowUpdatedEventArgs) Handles WebDataGrid1.RowUpdated
        Dim changes As DataTable = CType(WebDataGrid1.DataSource, DataTable).GetChanges()
        Dim s As String = String.Empty
        Session("data") = WebDataGrid1.DataSource
    End Sub


    Public Sub WebDataGrid1_RowUpdating(sender As Object, e As Infragistics.Web.UI.GridControls.RowUpdatingEventArgs) Handles WebDataGrid1.RowUpdating
        Dim s As String = String.Empty
    End Sub


    Protected Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim changes As DataTable = CType(WebDataGrid1.DataSource, DataTable).GetChanges()

        Dim s As String = String.Empty
    End Sub


#Region "--------------------------------   Properties, etc. ------------------------------------------------"
    Private miWidth As Integer = -1
    Private miHeight As Integer = -1
    'Private moColumnSettings As Collections.Generic.List(Of IpsGridColumnSettings)

    Public Enum ColumnTypes
        CalendarControl
        DropListControl
    End Enum

    Public Property DataSource() As Object
        Get
            Return WebDataGrid1.DataSource
        End Get
        Set(value As Object)
            WebDataGrid1.DataSource = value
        End Set
    End Property

    Public ReadOnly Property WebGrid() As GridControls.WebDataGrid
        Get
            Return WebDataGrid1
        End Get
    End Property

    Public Property Width As Integer
        Get
            If miWidth = -1 Then
                miWidth = WebDataGrid1.Width.Value
            End If
            Return miWidth
        End Get
        Set(value As Integer)
            miWidth = value
        End Set
    End Property

    Public Property Height As Integer
        Get
            If miHeight = -1 Then
                miHeight = WebDataGrid1.Height.Value
            End If

            Return miHeight
        End Get
        Set(value As Integer)
            miHeight = value
        End Set
    End Property

    Public Property AllowColumnResizing() As Boolean
        Get
            Return WebDataGrid1.Behaviors.ColumnResizing.Enabled
        End Get
        Set(value As Boolean)
            WebDataGrid1.Behaviors.ColumnResizing.Enabled = value
        End Set
    End Property

    Public Property AllowPaging() As Boolean
        Get
            Return WebDataGrid1.Behaviors.Paging.Enabled
        End Get
        Set(value As Boolean)
            WebDataGrid1.Behaviors.Paging.Enabled = value
        End Set
    End Property

    Public Property PagerAppearance() As GridControls.PagerAppearance
        Get
            Return WebDataGrid1.Behaviors.Paging.PagerAppearance
        End Get
        Set(value As GridControls.PagerAppearance)
            WebDataGrid1.Behaviors.Paging.PagerAppearance = value
        End Set
    End Property

    Public Property PagerMode() As GridControls.PagerMode
        Get
            Return WebDataGrid1.Behaviors.Paging.PagerMode
        End Get
        Set(value As GridControls.PagerMode)
            WebDataGrid1.Behaviors.Paging.PagerMode = value
        End Set
    End Property

    Public Property PagerSize() As Integer
        Get
            Return WebDataGrid1.Behaviors.Paging.PageSize
        End Get
        Set(value As Integer)
            WebDataGrid1.Behaviors.Paging.PageSize = value
        End Set
    End Property

    Public Property ShowRowSelectors() As Boolean
        Get
            Return WebDataGrid1.Behaviors.RowSelectors.Enabled
        End Get
        Set(value As Boolean)
            WebDataGrid1.Behaviors.RowSelectors.Enabled = value
        End Set
    End Property

    Public Property AllowSorting() As Boolean
        Get
            Return WebDataGrid1.Behaviors.Sorting.Enabled
        End Get
        Set(value As Boolean)
            WebDataGrid1.Behaviors.Sorting.Enabled = value
        End Set
    End Property

    Public Property SortingMode() As GridControls.SortingMode
        Get
            Return WebDataGrid1.Behaviors.Sorting.SortingMode
        End Get
        Set(value As GridControls.SortingMode)
            WebDataGrid1.Behaviors.Sorting.SortingMode = value
        End Set
    End Property

    Public Property AllowCellEditing() As Boolean
        Get
            Return WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.Enabled
        End Get
        Set(value As Boolean)
            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.Enabled = value
        End Set
    End Property


    'Public Property ColumnSettings() As Collections.Generic.List(Of IpsGridColumnSettings)
    '    Get
    '        If moColumnSettings Is Nothing Then
    '            moColumnSettings = New Collections.Generic.List(Of IpsGridColumnSettings)
    '        End If

    '        Return moColumnSettings
    '    End Get
    '    Set(value As Collections.Generic.List(Of IpsGridColumnSettings))
    '        moColumnSettings = value
    '    End Set
    'End Property
#End Region


    Private Sub SetGridDefaultSettings(psDataKeyFields As String)
        Try
            AllowColumnResizing = True
            AllowPaging = False
            AllowSorting = True
            SortingMode = GridControls.SortingMode.Single
            ShowRowSelectors = False
            AllowCellEditing = True

            WebDataGrid1.EnableAjaxViewState = True
            WebDataGrid1.EnableDataViewState = True
            WebDataGrid1.EnableViewState = True
            WebDataGrid1.DataKeyFields = psDataKeyFields

            WebDataGrid1.Behaviors.Selection.RowSelectType = GridControls.SelectType.Multiple
            WebDataGrid1.Behaviors.Selection.CellClickAction = GridControls.CellClickAction.Row

            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.EnableF2 = True
            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.EnableOnActive = True
            WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.MouseClick = GridControls.EditMouseClickAction.Single

        Catch ex As Exception
            Throw ex
        End Try
    End Sub
End Class